unit Initer;
//       ,
//    .

interface
uses KOLVersionInfo;

var
  ProgPath : string;
  VerInfo : TVerInfoFromFile;

procedure init;     //     .
procedure DeInit;   //     .
function Name2NID(const Name : string) : longword;  // NID  
function NID2Name(const NID : longword) : string;   //   NID

//,    VCL,     .
function IntPower(const Base: Extended; const Exponent: Integer): Extended;
function Power(const Base, Exponent: Extended): Extended;

implementation

uses Windows, KOL;

procedure init;
begin
  //     .
  //  -   .

  //    ...

  //      .
  ProgPath := ExtractFilePath(ParamStr(0));

  //        ...
  VerInfo := TVerInfoFromFile.Create;
  VerInfo.LoadInfo(ParamStr(0));
end;

procedure DeInit;
begin
  //     .
  //  -   .

  //     ...      ...
  VerInfo.Free;
end;

function Name2NID(const Name : string) : longword;

const
  LWMax = 4294967296;            //    longword.
  Format = 1000000000;

var
  i, modificator, NameLength : integer;
  PreNID : longword;   //  unsigned 32-bit.
  CurrChar : char;
  temp : int64;  // 64     longword.
  UCName : string;

  function LW_Perepolnenie(const value : int64) : int64;
  begin
    //    ,  value ,   
    // longword,       C++,
    //  ,    .

    If value > LWMax then begin
      // .
      modificator := Trunc(value/LWMax);
      Result := value-(LWMax*modificator);
    end
    else Result := value;   //    -    .

  end;

begin
  // NID  

  Result := 0;
  PreNID := 0;   //       :)

  NameLength := Length(Name);   //   .
  UCName := UpperCase(Name);    //    .

  //   ...
  For i := 1 to NameLength do begin
    CurrChar := UCName[i];
    temp := LW_Perepolnenie(Round(Power(5,(NameLength-i))));
    temp := LW_Perepolnenie(Ord(CurrChar) * temp);
    PreNID := LW_Perepolnenie(PreNID + temp);
  end;

  //     1000000000,    :)
  //..      2000000000.
  If PreNID > Format then begin
    modificator := Trunc(PreNID/Format);
    PreNID := PreNID-(Format*modificator);
  end;

  //..  .    :).
  Result := PreNID + Format;
end;

function NID2Name(const NID : longword) : string;
begin
  //   NID
end;





///////////////////////
//  ,    ...

function IntPower(const Base: Extended; const Exponent: Integer): Extended;
asm
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;

function Power(const Base, Exponent: Extended): Extended;
begin
  if Exponent = 0.0 then
    Result := 1.0               { n**0 = 1 }
  else if (Base = 0.0) and (Exponent > 0.0) then
    Result := 0.0               { 0**n = 0, n > 0 }
  else if (Frac(Exponent) = 0.0) and (System.Abs(Exponent) <= MaxInt) then
    Result := IntPower(Base, Integer(Trunc(Exponent)))
  else
    Result := Exp(Exponent * Ln(Base))
end;

end.
